@echo off
goto :start

  Invocation of Crane-sch2html.xsl stylesheet using either XSLT 1 or XSLT 2.

  Note that there are two ways to use this batch file:

   1) - from a command prompt you can invoke the batch file passing the
	filename of the Schematron schema as the first argument

   2) - from a Windows manager file window you can drag the Schematron schema
        and drop it on top of the icon for this batch file

  This batch file will first delete any HTML file named using ".html" at the
  end of the Schematron schema name, then create that file with the stylesheet.
  First this batch file will check for the Saxon XSLT 1 processor in the same
  directory as this file, and then will check for the Saxon XSLT 2 processor,
  and when neither can be found it invokes the Windows CScript processor and
  uses the XSLT DLL found in Windows.

  $Id: Crane-sch2html.bat,v 1.4 2008/07/07 19:44:06 gkholman Exp $

Copyright (C) - Crane Softwrights Ltd. 
              - http://www.CraneSoftwrights.com/links/res-dev.htm

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer. 
- Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation 
  and/or other materials provided with the distribution. 
- The name of the author may not be used to endorse or promote products 
  derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN 
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Note: for your reference, the above is the "Modified BSD license", this text
      was obtained 2002-12-16 at http://www.xfree86.org/3.3.6/COPYRIGHT2.html#5

:start
if a%1==a goto :noinput

echo This window will disappear when successful or stay open when an error
echo is encountered.
echo.

if not exist "%~dp0/Crane-sch2html.xsl" goto :noxsl

if not exist "%~dp0/saxon.jar" goto :not1
rem XSLT 1 invocation includes passed filename
if exist %1.html del %1.html
java -jar "%~dp0/saxon.jar" -o %1.html %1 "%~dp0/Crane-sch2html.xsl" inFileName=%1
if %errorlevel% neq 0 goto :problem
goto :success
:not1

if not exist "%~dp0/saxon9.jar" goto :not2
rem XSLT 2 invocation derives filename from document URI
if exist %1.html del %1.html
java -jar "%~dp0/saxon9.jar" -o %1.html %1 "%~dp0/Crane-sch2html.xsl"
if %errorlevel% neq 0 goto :problem
goto :success
:not2

echo Neither "saxon.jar" for XSLT 1 nor "saxon9.jar" for XSLT 2 exists
echo Please obtain one or the other from http://saxon.sf.net
echo.
echo Meanwhile, attempting to use MSXML built-in XSLT processor...

cscript //nologo "%~dp0Crane-sch2html.js" %1 "%~dp0Crane-sch2html.xsl" %1.html
if %errorlevel% neq 0 goto :problem
goto :success

:noxsl
echo The "Crane-sch2html.xsl" stylesheet must be in the same directory as this
echo batch file.
goto :message

:noinput
echo This invocation requires the Schematron schema filename to be passed 
echo as the first argument.  It is sufficient from a Windows Manager
echo graphical interface to simply drag and drop the schema onto the icon
echo of this batch file.
goto :message

:problem
if exist %1.html del %1.html
echo The invocation of the stylesheet has reported an error.
goto :message

:message
pause
goto :done

:success
if exist %1.html start "Result" %1.html
:done
